module Awsom
  class Config

    def initialize(config_path)
      @config_path = config_path
    end

    def config
      @config = {
        minion_config: {}
      }
      read_config
      @config
    end

    private

    def region(region)
      set :region, region
    end

    def vpc_id(vpc)
      set :vpc_id, vpc
    end

    def minion_config(config)
      set :minion_config, config
    end

    def aws_key(aws_key)
      set :aws_key, aws_key
      set :use_iam, false
    end

    def aws_secret(aws_secret)
      set :aws_secret, aws_secret
      set :use_iam, false
    end

    def set(key, value)
      @config.store key, value
    end

    def read_config
      read(@config_path, required: false)
    end

    def read(file, required: true)
      if not File.readable? file
        raise Error, "config: #{file} not readable" if required
        return
      end
      instance_eval(File.read(file), file)
    rescue NoMethodError => e
      raise Error, "invalid option used in config: #{e.name}"
    end
  
  end
end
